local frame = CreateFrame("FRAME")
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("PLAYER_LOGOUT")
frame:RegisterEvent("UPDATE_FACTION")
function frame:OnEvent(event, arg1)
	if event == "ADDON_LOADED" and arg1 == "RepCalc" then
		RepCalcDB = RepCalcDB or {}
		if RepCalcDB.RepName then RC_CreateBars(); RC_CreateConfig(); RepCalcDB.RunSetup = true; RepCalcDB.ConfigOpen = false; frame:UnregisterEvent("ADDON_LOADED"); end
	elseif event == "PLAYER_LOGOUT" then
		if RepCalcDB.RepName[1] == nil then RepCalcDB = nil; frame:UnregisterEvent("PLAYER_LOGOUT"); end
	elseif event == "UPDATE_FACTION" then
		if RepCalcDB.RunSetup == true and RepCalcDB.Visible == true then UpdateReps(); end
	end
end
frame:SetScript("OnEvent", frame.OnEvent);

SLASH_REPCALC1 = '/repcalc';
function SlashCmdList.REPCALC(msg, editbox)
	if _G["RepCalc_Config"] == nil then RC_CreateConfig() end
	if _G["RepCalc_Header"] == nil then RC_CreateBars() end
	if RepCalcDB.RunSetup == nil then 
		RepConfig_Show(); RepCalcDB.RunSetup = true 
	elseif RepCalcDB.ConfigOpen == false then 
		UpdateReps()
	end
end

SLASH_RCCONFIG1 = '/rcconfig';
function SlashCmdList.RCCONFIG(msg, editbox)
	if _G["RepCalc_Config"] == nil then RC_CreateConfig() end
	if _G["RepCalc_Header"] == nil then RC_CreateBars() end
	if RepCalcDB.RunSetup == nil then 
		RepCalcDB.RunSetup = true; FillConfig(); RepConfig_Show()
	else 
		RepCalc_Hide()
		RepConfig_Show()
	end
end

function RC_CreateConfig()
	local fra = CreateFrame("Frame","RepCalc_Config",UIParent)
	fra:SetSize(615, 440)
	fra:SetFrameStrata("HIGH")
	fra:SetMovable(true)
	fra:EnableMouse(true)
	fra:RegisterForDrag("LeftButton")
	fra:SetScript("OnDragStart", frame.StartMoving)
	fra:SetScript("OnDragStop", frame.StopMovingOrSizing)
	fra:SetPoint("CENTER"); 
	fra:Hide()
	local tex = fra:CreateTexture("$parent_Background","ARTWORK")
	tex:SetAllPoints();
	tex:SetTexture(0, 0, 0); tex:SetAlpha(0.7);
	local ttl = fra:CreateFontString("HeaderText","OVERLAY","GameFontNormal") --Header
	ttl:SetPoint("TOPLEFT",fra,"TOPLEFT",4,-3)
	ttl:SetText("Rep Calculator Config")
	local desc = fra:CreateFontString("HeaderDesc","OVERLAY","GameFontNormalSmall") --Help Text
	desc:SetPoint("TOPLEFT",fra,"TOPLEFT",5,-22)
	desc:SetText("Select reputations to track (10 maximum).\nKey: |cff00FF7FMists of Pandaria, |cFFFF6060Cataclysm, |cFF1E90FFWrath of the Lich King, |cFF9370DBBurning Crusade.")
	desc:SetJustifyH("LEFT")
	local ttle = fra:CreateFontString("TitleError","OVERLAY","GameFontNormalSmall") --Error Text
	ttle:SetPoint("TOPLEFT",fra,"TOPLEFT",6,-62)
	ttle:SetText("No honored or revered reputations found.")
	ttle:Hide()
	local btn = CreateFrame("Button","RCConfig_Button",fra,"UIPanelButtonTemplate") --Save Button
	btn:SetSize(70, 25)
	btn:SetPoint("TOPRIGHT",fra,"TOPRIGHT",-2,-2)
	btn:SetText("Save")
	btn:SetScript("OnClick", function (self, button, down) if button == "LeftButton" then RCConfig_Button(); end end)
	btn:Show()
	--Checkboxes
	local x = 2
	local y = -55
	for i = 1, 45 do
		local chkbox = CreateFrame("CheckButton", "$parent_CheckButton"..i, fra, "UICheckButtonTemplate")
		chkbox:SetSize(25, 25)
		if i == 16 then x = 205; y = -55 end --2nd column
		if i == 31 then x = 410; y = -55 end --3rd column
		chkbox:SetPoint("TOPLEFT",fra,"TOPLEFT",x, y)
		y = y - 25
	end
end

function RC_CreateBars()
	-- Header
	local fra = CreateFrame("Frame","RepCalc_Header",UIParent)
	fra:SetSize(215, 22)
	fra:SetFrameStrata("HIGH")
	fra:SetMovable(true)
	fra:EnableMouse(true)
	fra:RegisterForDrag("LeftButton")
	fra:SetScript("OnDragStart", frame.StartMoving)
	fra:SetScript("OnDragStop", frame.StopMovingOrSizing)
	fra:SetScript("OnMouseUp", function (self, button) if button == "RightButton" then RepCalc_Hide(); RepConfig_Show(); end end)
	fra:SetPoint("CENTER"); 
	fra:Hide()
	local tex = fra:CreateTexture("$parent_Background","ARTWORK")
	tex:SetAllPoints();
	tex:SetTexture(0, 0, 0, 0.8)
	-- Title
	local ttl = fra:CreateFontString("HeaderText","OVERLAY","GameFontNormal")
	ttl:SetPoint("TOPLEFT",fra,"TOPLEFT",4,-4)
	ttl:SetText("Rep Calculator")
	-- Close Button
	local btn = CreateFrame("Button","$parent_CloseButton",fra,"UIPanelCloseButton")
	btn:SetPoint("TOPRIGHT",fra,"TOPRIGHT",4,5)
	btn:SetScript("OnClick", function (self, button, down) if button == "LeftButton" then RepCalc_Hide(); end end)
	btn:Show()
	--Rep Bars
	local fraTop = fra
	local fraBelow
	for i = 1, 10 do
		--Rep Bar Frame
		fraBelow = CreateFrame("Frame","RepCalc_Frame"..i,fra)
		fraBelow:SetPoint("TOPLEFT",fraTop,"BOTTOMLEFT",0,0)
		fraBelow:SetSize(215, 25)
		fraBelow:SetScript("OnMouseUp", function (self, button) if button == "LeftButton" then ShowRepInfo(i) end end)
		fraBelow:Hide()
		local tex = fraBelow:CreateTexture("$parent_Background","BACKGROUND")
		tex:SetAllPoints();
		tex:SetTexture(0, 0, 0, 0.7)
		--StatusBar
		bar = CreateFrame("StatusBar", "RepCalc_StatusBar"..i, fraBelow);
		bar:SetSize(212, 25)
		bar:SetAllPoints("RepCalc_Frame"..i)
		bar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
		bar:SetMinMaxValues(0, 1000)
		bar:SetStatusBarColor(0, 0.6, 0, 1)
		bar:Show()
		--StatusBar Text
		bartxt = bar:CreateFontString("RepCalc_StatusBar"..i.."Text",nil,"GameFontNormalSmall")
		bartxt:SetPoint("TOPLEFT",bar,"TOPLEFT",3,1)
		bartxt:SetSize(212, 25)
		bartxt:SetJustifyH("LEFT"); bartxt:SetJustifyV("MIDDLE")
		bartxt:SetAlpha(1)
		bartxt:Show()
		fraTop = fraBelow
	end
end

function RepCalc_Hide()
	RepCalcDB.Visible = false
	local frheader = _G["RepCalc_Header"]
	frheader:Hide()
	for i = 1, 10 do
		local fr = _G["RepCalc_Frame"..i]
		fr:Hide()
	end
end

function RepConfig_Show()
	local rc_config = _G["RepCalc_Config"]
	FillConfig()
	rc_config:Show()
	RepCalcDB.ConfigOpen = true
end

function RepConfig_Hide()
	local rc_config = _G["RepCalc_Config"]
	rc_config:Hide()
	RepCalcDB.ConfigOpen = false
end

function MakeBar(num, value)
	local topVal, earntVal, totalReq, standName = CalcRepReq(RepCalcDB.RepName[value])
	local RepPercent = (earntVal / topVal)*1000; 
	local RepText = RepCalcDB.RepName[value] .. " (" .. earntVal .. "/" .. topVal .. ")\n"..standName
	local bar = _G["RepCalc_StatusBar" .. num]
	local bartxt = _G["RepCalc_StatusBar" .. num .. "Text"]
	bar:SetValue(RepPercent)
	bartxt:SetText(RepText)
	if topVal == 3000 then bar:SetStatusBarColor(0.7, 0.4, 0, 1) elseif topVal == 6000 then bar:SetStatusBarColor(0, 0.7, 0, 1)--Neutral/Friendly
	elseif topVal == 12000 then bar:SetStatusBarColor(0, 0.6, 0, 1) else bar:SetStatusBarColor(0, 0.5, 0, 1) end--Honored/Revered

	local currentID 
	for i = 1, 200 do
		local name, description, standingId, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(i);
		if name == RepCalcDB.RepName[value] then currentID = factionID; break end
	end
	local friendID, friendRep, friendMaxRep, friendName, friendText, friendTexture, friendTextLevel = GetFriendshipReputationByID(currentID);
	if friendID ~= nil then 
		if friendRep < 8400 then bar:SetStatusBarColor(0.7, 0.4, 0, 1)
		elseif friendRep > 8400 and friendRep < 16800 then bar:SetStatusBarColor(0, 0.7, 0, 1)
		elseif friendRep > 16800 and friendRep < 25200 then bar:SetStatusBarColor(0, 0.6, 0, 1)
		elseif friendRep > 25200 and friendRep < 33600 then bar:SetStatusBarColor(0, 0.6, 0, 1)
		elseif friendRep > 33600 and friendRep < 42000 then bar:SetStatusBarColor(0, 0.5, 0, 1)
		end
	end

end

function FillConfig()

	local tempName = ""
	local highVal = 0
	local prevVal = 0
	local repPercent
	local trackedReps = {}

	if RepCalcDB.RepName ~= nil then 
		--Record currently tracked reps in case of reordering
		local x = 1
		for i = 1, #RepCalcDB.RepName do
			if RepCalcDB.RepNum[i] == 1 then trackedReps[x] = RepCalcDB.RepName[i]; x=x+1; end
		end
	end

	if not RepCalcDB.RepNum then RepCalcDB.RepNum = {} end
	RepCalcDB.RepName = {}
	local currentID = 0
	local standID = 0

	for i = 1, 45 do -- Uncheck all boxes
		local checkbox = _G["RepCalc_Config_CheckButton" .. i]
		checkbox:SetChecked(false)
	end

	--loop thru for 20 checkboxes
	for i = 1, 45 do
		for idx = 1, 200 do -- loop thru all reps
			local name, description, standingId, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(idx);
			if name == "Inactive" then break end
			if not name then break end -- last one reached
			if standingId > 3 and standingId < 8 and name ~= "Guild" and name ~= "Alliance" and name ~= "Alliance Forces" and name ~= "Horde" and name ~= "Horde Forces" and name ~= "Steamwheedle Cartel" and name ~= "Sholazar Basin" then
				if barValue > highVal then
					if barValue < prevVal or prevVal == 0 then
						highVal = barValue
						currentID = factionID
						tempName = name
						repPercent = ceil((barValue - barMin) / (barMax - barMin) * 100)
						standID = standingId
					end
				end
			end
		end	
		if RepCalcDB.RepName[i-1] == tempName and i > 1 then break; -- Run out of reps
		elseif repPercent ~= nil then 
			prevVal = highVal; highVal = 0
			if RepCalcDB.RepNum[1] == nil then RepCalcDB.RepNum[i] = 0; end 
			RepCalcDB.RepName[i] = tempName
			
			local checkbox = _G["RepCalc_Config_CheckButton" .. i]
			local checktxt =  _G[checkbox:GetName().."Text"]
			checktxt:SetJustifyH("Left")

			local MoPReps = {"Golden Lotus","Order of the Cloud Serpent","Shado-Pan","The August Celestials","The Black Prince","The Klaxxi","The Lorewalkers","The Anglers","Nat Pagle","The Tillers",
				"Chee Chee","Ella","Farmer Fung","Fish Fellreed","Gina Mudclaw","Haohan Mudclaw","Jogu the Drunk","Old Hillpaw","Sho","Tina Mudclaw"}
			local CataReps = {"Avengers of Hyjal","Baradin's Wardens","Guardians of Hyjal","Ramkahen","The Earthen Ring","Therazane","Wildhammer Clan"}
			local WrathReps = {"Argent Crusade","Kirin Tor","Knights of the Ebon Blade","The Ashen Verdict","The Kalu'ak","The Sons of Hodir","The Wyrmrest Accord","Alliance Vanguard",
				"Explorers' League","The Frostborn","The Silver Covenant","Valiance Expedition"}
			local BCReps = {"Cenarion Expedition","Honor Hold","Keepers of Time","Kurenai","Sporeggar","The Consortium","The Violet Eye","Lower City","Sha'tari Skyguard",
				"Shattered Sun Offensive","The Aldor","The Scryers","The Sha'tar"}

			local friendID, friendRep, friendMaxRep, friendName, friendText, friendTexture, friendTextLevel = GetFriendshipReputationByID(currentID);
			if (friendRep ~= nil) then
				if friendRep < 8400 then checktxt:SetText(tempName.." (" .. repPercent .. "%)\nStranger");
				elseif friendRep > 8400 and friendRep < 16800 then checktxt:SetText(tempName.." (" .. repPercent .. "%)\nAcquaintance");
				elseif friendRep > 16800 and friendRep < 25200 then checktxt:SetText(tempName.." (" .. repPercent .. "%)\nBuddy");
				elseif friendRep > 25200 and friendRep < 33600 then checktxt:SetText(tempName.." (" .. repPercent .. "%)\nFriend");
				elseif friendRep > 33600 and friendRep < 42000 then checktxt:SetText(tempName.." (" .. repPercent .. "%)\nGood Friend");
				end
			else
				if standID == 4 then checktxt:SetText(tempName .. " (" .. repPercent .. "%)\nNeutral"); --Neutral
				elseif standID == 5 then checktxt:SetText(tempName .. " (" .. repPercent .. "%)\nFriendly"); --Friendly
				elseif standID == 6 then checktxt:SetText(tempName .. " (" .. repPercent .. "%)\nHonored"); --Honored
				else checktxt:SetText(tempName .. " (" .. repPercent .. "%)\nRevered"); end --Revered
			end

			for i = 1, #MoPReps do if tempName == MoPReps[i] then _G[checkbox:GetName().."Text"]:SetText("|cff00FF7F".._G[checkbox:GetName().."Text"]:GetText()) end end
			for i = 1, #CataReps do if tempName == CataReps[i] then _G[checkbox:GetName().."Text"]:SetText("|cFFFF6060".._G[checkbox:GetName().."Text"]:GetText()) end end
			for i = 1, #WrathReps do if tempName == WrathReps[i] then _G[checkbox:GetName().."Text"]:SetText("|cFF1E90FF".._G[checkbox:GetName().."Text"]:GetText()) end end
			for i = 1, #BCReps do if tempName == BCReps[i] then _G[checkbox:GetName().."Text"]:SetText("|cFF9370DB".._G[checkbox:GetName().."Text"]:GetText()) end end--|cFF7FFFD4
			checkbox:Show()

			if #trackedReps ~= 0 then
				for i = 1, #trackedReps do --Compare to previously tracked reps array
					if trackedReps[i] == tempName then checkbox:SetChecked(true); end
				end
			end
		end
	end
	for i = 1, 45 do -- Hide unused checkboxes
		if RepCalcDB.RepName[i] == nil then
			local checkbox = _G["RepCalc_Config_CheckButton" .. i]
			checkbox:Hide()
		end
	end
	local errString = _G["TitleError"] -- Hide/Show error text if no reps
	if tempName == "" then errString:Show()
	else errString:Hide() end

	local fra = _G["RepCalc_Config"]
	if #RepCalcDB.RepName < 31 then fra:SetSize(410, 440) else fra:SetSize(615, 440) end
end

function RCConfig_Button()
	if RepCalcDB.RepName[1] ~= nil then
		local maxNum = 1 
		for i = 1, 45 do
			if maxNum > 10 then maxNum=i; break end --Maximum 10 reps
			local checkbox = _G["RepCalc_Config_CheckButton" .. i]
			if checkbox:GetChecked() then RepCalcDB.RepNum[i] = 1; maxNum=maxNum+1
			else RepCalcDB.RepNum[i] = 0 end
		end
		for i = maxNum, 30 do --Uncheck boxes past 10 max
			local checkbox = _G["RepCalc_Config_CheckButton" .. i]
			checkbox:SetChecked(0)
		end
		RepConfig_Hide()
		UpdateReps()
	else
		RepConfig_Hide()
		RepCalcDB.RunSetup = nil
	end
end

function UpdateReps()
	RepCalcDB.Visible = true
	local headerframe = _G["RepCalc_Header"]
	headerframe:Show()
	local barnum = 1
	for repnum = 1, 45 do
		if RepCalcDB.RepNum[repnum] == 1 then
			local topVal, earntVal, totalReq = CalcRepReq(RepCalcDB.RepName[repnum])
			local fr = _G["RepCalc_Frame" .. barnum]
			if barnum <= 10 then
				if topVal ~= nil then -- zoning error bugfix
					MakeBar(barnum, repnum)
					fr:Show()
					barnum=barnum+1
				end
			end
		end
	end
end

function CalcRepReq(faction)
	local topVal
	local earntVal
	local totalReq
	local standName
	for factionIndex = 1, 200 do
		  local name, description, standingId, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(factionIndex);
		  if not name then break; -- No more factions
		  elseif name == faction then
		    if standingId == 7 then totalReq = (barMax - barValue); standName = "Revered" --Revered
		    elseif standingId == 6 then totalReq = (barMax - barValue)+21000; standName = "Honored" --Honored
		    elseif standingId == 5 then totalReq = (barMax - barValue)+33000; standName = "Friendly" --Friendly
		    elseif standingId == 4 then totalReq = (barMax - barValue)+39000; standName = "Neutral" 
		    else standName = "Exalted" end --Neutral
		    topVal = barMax - barMin
		    earntVal = barValue - barMin

		    local friendID, friendRep, friendMaxRep, friendName, friendText, friendTexture, friendTextLevel = GetFriendshipReputationByID(factionID);
		    if (friendRep ~= nil) then
			topVal = 8400
			earntVal = friendRep - friendTextLevel
			if friendRep < 8400 then standName = "Stranger"
			elseif friendRep > 8400 and friendRep < 16800 then standName = "Acquaintance"
			elseif friendRep > 16800 and friendRep < 25200 then standName = "Buddy"
			elseif friendRep > 25200 and friendRep < 33600 then standName = "Friend"
			elseif friendRep > 33600 and friendRep < 42000 then standName = "Good Friend"
			else standName = "Best Friend" end
		    end

		    break

		  end
	end
	return topVal, earntVal, totalReq, standName
end

function ShowRepInfo(barnum)
  local x = 1
  local RC_Bonus = 1
  for i = 1, 45 do
    if RepCalcDB.RepNum[i] == 1 then
      if x < barnum then x=x+1
      else
        --Calc any rep bonuses
        if UnitRace("player") == "Human" then RC_Bonus = 0.9 end
        if IsInGuild() == 1 then
          if GetGuildLevel() > 11 then RC_Bonus = RC_Bonus - 0.1
          elseif GetGuildLevel() > 3 then RC_Bonus = RC_Bonus - 0.05
          end
        end
	--Calc requirements to exalted
        local RepName = RepCalcDB.RepName[i]
	local RepTop, RepAmt, RepTotal = CalcRepReq(RepName)
	if RepTotal == nil then break end
	local itemAmt
	if RepName ~= "Wintersaber Trainers" then RepTotal = RepTotal*RC_Bonus end

	local dailyReps = {"Darkmoon Faire", "Baradin's Wardens", "Hellscream's Reach", "Wildhammer Clan", "Dragonmaw Clan", "Therazane", "Netherwing"}
	for i = 1, #dailyReps do -- Reps with dailies
	  if dailyReps[i] == RepName then
	    local dailyAmt = ceil(RepTotal / 250)
	    DEFAULT_CHAT_FRAME:AddMessage("RepCalc: Approx " .. dailyAmt ..  " dailies required to reach exalted with " .. RepName .. ".", 0, 0.7, 1);
	  end
	end

	local farmReps = {"Chee Chee","Ella","Farmer Fung","Fish Fellreed","Gina Mudclaw","Haohan Mudclaw","Jogu the Drunk","Old Hillpaw","Sho","Tina Mudclaw"}
	for i = 1, #farmReps do -- Farmers
	  if farmReps[i] == RepName then
	    local foodAmt = ceil(RepTotal / 1800)
	    local itemAmt = ceil(RepTotal / 900)
	    if RepName == "Old Hillpaw" then DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You require " .. foodAmt ..  " \124cffffffff\124Hitem:74649:0:0:0:0:0:0:0:0\124h[Braised Turtle]\124h\124r hand-ins, or "..itemAmt.." \124cff0070dd\124Hitem:79265:0:0:0:0:0:0:0:0\124h[Blue Feather]\124h\124r hand-ins to become Best Friends with " .. RepName .. ".", 0, 0.7, 1) end
	    if RepName == "Chee Chee" then DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You require " .. foodAmt ..  " \124cffffffff\124Hitem:74647:0:0:0:0:0:0:0:0\124h[Valley Stir Fry]\124h\124r hand-ins, or "..itemAmt.." \124cff0070dd\124Hitem:79265:0:0:0:0:0:0:0:0\124h[Blue Feather]\124h\124r hand-ins to become Best Friends with " .. RepName .. ".", 0, 0.7, 1) end
	    if RepName == "Ella" then DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You require " .. foodAmt ..  " \124cffffffff\124Hitem:74651:0:0:0:0:0:0:0:0\124h[Shrimp Dumplings]\124h\124r hand-ins, or "..itemAmt.." \124cff0070dd\124Hitem:79266:0:0:0:0:0:0:0:0\124h[Jade Cat]\124h\124r hand-ins to become Best Friends with " .. RepName .. ".", 0, 0.7, 1) end
	    if RepName == "Fish Fellreed" then DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You require " .. foodAmt ..  " \124cffffffff\124Hitem:74655:0:0:0:0:0:0:0:0\124h[Twin Fish Platter]\124h\124r hand-ins, or "..itemAmt.." \124cff0070dd\124Hitem:79266:0:0:0:0:0:0:0:0\124h[Jade Cat]\124h\124r hand-ins to become Best Friends with " .. RepName .. ".", 0, 0.7, 1) end
	    if RepName == "Jogu the Drunk" then DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You require " .. foodAmt ..  " \124cffffffff\124Hitem:74643:0:0:0:0:0:0:0:0\124h[Sauteed Carrots]\124h\124r hand-ins, or "..itemAmt.." \124cff0070dd\124Hitem:79267:0:0:0:0:0:0:0:0\124h[Lovely Apple]\124h\124r hand-ins to become Best Friends with " .. RepName .. ".", 0, 0.7, 1) end
	    if RepName == "Sho" then DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You require " .. foodAmt ..  " \124cffffffff\124Hitem:74645:0:0:0:0:0:0:0:0\124h[Eternal Blossom Fish]\124h\124r hand-ins, or "..itemAmt.." \124cff0070dd\124Hitem:79267:0:0:0:0:0:0:0:0\124h[Lovely Apple]\124h\124r hand-ins to become Best Friends with " .. RepName .. ".", 0, 0.7, 1) end
	    if RepName == "Farmer Fung" then DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You require " .. foodAmt ..  " \124cffffffff\124Hitem:74654:0:0:0:0:0:0:0:0\124h[Wildfowl Roast]\124h\124r hand-ins, or "..itemAmt.." \124cff0070dd\124Hitem:79268:0:0:0:0:0:0:0:0\124h[Marsh Lily]\124h\124r hand-ins to become Best Friends with " .. RepName .. ".", 0, 0.7, 1) end
    	    if RepName == "Gina Mudclaw" then DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You require " .. foodAmt ..  " \124cffffffff\124Hitem:74644:0:0:0:0:0:0:0:0\124h[Swirling Mist Soup]\124h\124r hand-ins, or "..itemAmt.." \124cff0070dd\124Hitem:79268:0:0:0:0:0:0:0:0\124h[Marsh Lily]\124h\124r hand-ins to become Best Friends with " .. RepName .. ".", 0, 0.7, 1) end
	    if RepName == "Haohan Mudclaw" then DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You require " .. foodAmt ..  " \124cffffffff\124Hitem:74642:0:0:0:0:0:0:0:0\124h[Charbroiled Tiger Steak]\124h\124r hand-ins, or "..itemAmt.." \124cff0070dd\124Hitem:79264:0:0:0:0:0:0:0:0\124h[Ruby Shard]\124h\124r hand-ins to become Best Friends with " .. RepName .. ".", 0, 0.7, 1) end
    	    if RepName == "Tina Mudclaw" then DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You require " .. foodAmt ..  " \124cffffffff\124Hitem:74652:0:0:0:0:0:0:0:0\124h[Fire Spirit Salmon]\124h\124r hand-ins, or "..itemAmt.." \124cff0070dd\124Hitem:79264:0:0:0:0:0:0:0:0\124h[Ruby Shard]\124h\124r hand-ins to become Best Friends with " .. RepName .. ".", 0, 0.7, 1) end
	  end
	end

	if RepName == "Cenarion Circle" then 
	  itemAmt = ceil(RepTotal / 500) * 10
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You require " .. itemAmt ..  " \124cffffffff\124Hitem:20404:0:0:0:0:0:0:0:0\124h[Encrypted Twilight Text]\124h\124r to reach exalted with Cenarion Circle.", 0, 0.7, 1);
	elseif RepName == "Kurenai" or RepName == "Mag'har" then
	  itemAmt = ceil(RepTotal / 500) * 10
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You require " .. itemAmt ..  " \124cffffffff\124Hitem:25433:0:0:0:0:0:0:0:0\124h[Obsidian Warbeads]\124h\124r to reach exalted with " .. RepName ..  ".", 0, 0.7, 1);
	elseif RepName == "The Consortium" then
	  itemAmt = ceil(RepTotal / 250) * 10
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You require " .. itemAmt ..  " \124cffffffff\124Hitem:25433:0:0:0:0:0:0:0:0\124h[Obsidian Warbeads]\124h\124r or \124cffffffff\124Hitem:29209:0:0:0:0:0:0:0:0\124h[Zaxxis Insignia]\124h\124r to reach exalted with " .. RepName ..  ".", 0, 0.7, 1);
	elseif RepName == "Sporereggar" then
	  itemAmt = ceil(RepTotal / 750)* 5
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You require " .. itemAmt ..  " \124cffffffff\124Hitem:24246:0:0:0:0:0:0:0:0\124h[Sanguine Hibiscus]\124h\124r to reach exalted with " .. RepName ..  ".", 0, 0.7, 1);
	elseif RepName == "Wintersabre Trainers" then
	  RepTotal = RepTotal - 10000;
	  itemAmt = ceil(RepTotal / 1500)
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You have " .. itemAmt ..  " days of daily quests until exalted with " .. RepName ..  ".", 0, 0.7, 1);
	elseif RepName == "Ravenholdt" then
	  itemAmt = ceil(RepTotal / 75) * 5
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You require " .. itemAmt ..  " \124cffffffff\124Hitem:16885:0:0:0:0:0:0:0:0\124h[Heavy Junkbox]\124h\124r to reach exalted with " .. RepName ..  ".", 0, 0.7, 1);
	elseif RepName == "Sha'tari Skyguard" then
	  itemAmt = ceil(RepTotal / 150) * 6
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You require " .. itemAmt ..  " \124cffffffff\124Hitem:32388:0:0:0:0:0:0:0:0\124h[Shadow Dust]\124h\124r to reach exalted with " .. RepName ..  ".", 0, 0.7, 1);
	elseif RepName == GetGuildInfo("player") then -- Guild Reputation
	  itemAmt = ceil(RepTotal / 166.6)
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: Approx " .. itemAmt ..  " quest hand-ins (" .. ceil(itemAmt/2) .. " with \124cffa335ee\124Hitem:69210:0:0:0:0:0:0:0:0\124h[Renowned Guild Tabard]\124h\124r) required to reach exalted with your guild.", 0, 0.7, 1);
	elseif RepName == "The Sons of Hodir" or RepName == "Ogri'la" then
	  local dailyAmt = ceil(RepTotal / 350)
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: Approx " .. dailyAmt ..  " dailies required to reach exalted with " .. RepName .. ".", 0, 0.7, 1);
	elseif RepName == "The Kalu'ak" then
	  local dailyAmt = ceil(RepTotal / 500)
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: Approx " .. dailyAmt ..  " dailies required to reach exalted with " .. RepName .. ".", 0, 0.7, 1);
	elseif RepName == "Timbermaw Hold" then
	  local itemAmt = ceil(RepTotal / 2000)* 5
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You require " .. itemAmt ..  " \124cffffffff\124Hitem:21383:0:0:0:0:0:0:0:0\124h[Winterfall Spirit Beads]\124h\124r to reach exalted with " .. RepName ..  ".", 0, 0.7, 1);
	elseif RepName == "The Scale of the Sands" then
	  local itemAmt = ceil(RepTotal / 7800)
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: Approx " .. itemAmt ..  " full Hyjal Summit clears to reach exalted with " .. RepName ..  ".", 0, 0.7, 1);
	elseif RepName == "The Scryers" then
	  local itemAmt = ceil(RepTotal / 350)
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You require " .. itemAmt ..  " \124cff1eff00\124Hitem:29739:0:0:0:0:0:0:0:0\124h[Arcane Tome]\124h\124r to reach exalted with " .. RepName ..  ".", 0, 0.7, 1);
	elseif RepName == "The Aldor" then
	  local itemAmt = ceil(RepTotal / 350)
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You require " .. itemAmt ..  " \124cff1eff00\124Hitem:29740:0:0:0:0:0:0:0:0\124h[Fel Armament]\124h\124r to reach exalted with " .. RepName ..  ".", 0, 0.7, 1);
	elseif RepName == "Silverwing Sentinels" or RepName == "Warsong Outriders" then
	  local itemAmt = ceil(RepTotal / 35)
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You require " .. itemAmt ..  " Warsong Gulch flag captures to reach exalted with " .. RepName ..  ".", 0, 0.7, 1);
	elseif RepName == "The League of Arathor" or RepName == "The Defilers" then
	  local itemAmt = ceil(RepTotal / 100)
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: You require " .. itemAmt ..  " Arathi Basin wins to reach exalted with " .. RepName ..  ".", 0, 0.7, 1);
	elseif RepName == "The Anglers" then
	  local itemAmt = ceil(RepTotal / 500)
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: Approx " .. itemAmt ..  " daily quests until exalted with " .. RepName ..  ".", 0, 0.7, 1);
	elseif RepName == "The Tillers" then
	  local itemAmt = ceil(RepTotal / 150)
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: Approx " .. itemAmt ..  " daily quests until exalted with " .. RepName ..  ".", 0, 0.7, 1);
	elseif RepName == "The Klaxxi" then
	  local itemAmt = ceil(RepTotal / 130)
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: Approx " .. itemAmt ..  " daily quests until exalted with " .. RepName ..  ".", 0, 0.7, 1);
	elseif RepName == "Golden Lotus" then
	  local itemAmt = ceil(RepTotal / 100)
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: Approx " .. itemAmt ..  " daily quests until exalted with " .. RepName ..  ".", 0, 0.7, 1);
  	elseif RepName == "The August Celestials" then
	  local itemAmt = ceil(RepTotal / 300)
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: Approx " .. itemAmt ..  " daily quests until exalted with " .. RepName ..  ".", 0, 0.7, 1);
	elseif RepName == "Shado-Pan" then
	  local itemAmt = ceil(RepTotal / 250)
	  DEFAULT_CHAT_FRAME:AddMessage("RepCalc: Approx " .. itemAmt ..  " daily quests until exalted with " .. RepName ..  ".", 0, 0.7, 1);
	end
        break
      end
    end
  end
end